Imports System.Runtime.InteropServices

Friend NotInheritable Class NativeMethods
    Private Sub New()
        '
    End Sub

    Friend Declare Function GetWindowDC Lib "user32.dll" ( _
        ByVal hwnd As IntPtr _
    ) As IntPtr

    Friend Declare Function ReleaseDC Lib "user32.dll" ( _
        ByVal hwnd As IntPtr, _
        ByVal hdc As IntPtr _
    ) As Int32

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure RECT
        Public Sub New( _
            ByVal Left As Integer, _
            ByVal Top As Integer, _
            ByVal Right As Integer, _
            ByVal Bottom As Integer _
        )
            Me.Left = Left
            Me.Top = Top
            Me.Right = Right
            Me.Bottom = Bottom
        End Sub

        Public Left As Int32
        Public Top As Int32
        Public Right As Int32
        Public Bottom As Int32
    End Structure

    Friend Const WM_NCCALCSIZE As Int32 = &H83
    Friend Const WM_NCPAINT As Int32 = &H85
    Friend Const WM_THEMECHANGED As Int32 = &H31A

    Friend Declare Function RedrawWindow Lib "user32.dll" ( _
        ByVal hwnd As IntPtr, _
        ByRef lprcUpdate As RECT, _
        ByVal hrgnUpdate As IntPtr, _
        ByVal flags As RDW_Flags _
    ) As Boolean

    <Flags()> _
    Friend Enum RDW_Flags
        RDW_FRAME = &H400
        RDW_INVALIDATE = &H1
        RDW_NOERASE = &H20
        RDW_NOCHILDREN = &H40
        RDW_UPDATENOW = &H100
    End Enum

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure NCCALCSIZE_PARAMS
        Public rgrc0 As RECT
        Public rgrc1 As RECT
        Public rgrc2 As RECT
        Public lppos As IntPtr
    End Structure

    Friend Const CONST_OBJID_VSCROLL As Int32 = &HFFFFFFFB
    Friend Const CONST_OBJID_HSCROLL As Int32 = &HFFFFFFFA

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure SCROLLBARINFO
        Public cbSize As Int32
        Public rcScrollBar As RECT
        Public dxyLineButton As Int32
        Public xyThumbTop As Int32
        Public xyThumbBottom As Int32
        Public reserved As Int32
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> _
        Public rgstate() As Int32
    End Structure

    Friend Declare Function GetScrollBarInfo Lib "user32.dll" ( _
        ByVal hwnd As IntPtr, _
        ByVal idObject As Int32, _
        ByRef psbi As SCROLLBARINFO _
    ) As Boolean

    Friend Const STATE_SYSTEM_INVISIBLE As Int32 = &H8000
End Class